# frozen_string_literal: true

class Hermes::Api::Dmo::AccountingsController < Hermes::Api::Dmo::ApplicationController
  
  class << self
    def acceptable_params
      {
        object_id: {type: 'String', description: "id of the object (request or offer)"},
        target: {type: 'String', description: 'String values "request" or "offer"'},
        year: {type: 'String', description: "Year of the accounting"},
      }.merge(super)
    end 

    def valid_operators
      %w[$in $nin $ne $gt $gte $lt $lte $eq $regex $all]
    end
  end

  def index
    acceptable_params *self.class.acceptable_params.keys
    valid_operators *self.class.valid_operators
    super
  end
end