# frozen_string_literal: true

# Hash class utilitary methods
class Hash
  def inverted_values
    each_with_object({}) do |(key, val), h|
      h[key] = case val.class.name
               when /Hash|Mongoid::Document|ActionRecord::Parameters/
                 val.inverted_values
               when 'Array'
                 val.inverted_values
               else
                 val * -1
               end
    end
  end

  def unnegate
    each_with_object({}) do |(key, val), h|
      h[key] = case val.class.name
               when /Hash|Mongoid::Document|ActionRecord::Parameters/
                 val.unnegate
               when 'Array'
                 val.unnegate
               else
                 val.negative? ? 0 : val
               end
    end
  end

  def all_to(type)
    each_with_object({}) do |(key, val), h|
      h[key] = case val.class.name
               when /Hash|Mongoid::Document|ActionRecord::Parameters/
                 val.all_to(type)
               when 'Array'
                 val.all_to(type)
               else
                 case type&.name
                 when 'String'
                   val.to_s rescue nil
                 when 'Integer'
                   Integer(val) rescue nil
                 when 'Float'
                   Float(val) rescue nil
                 else
                   val
                 end
               end
    end
  end
end
