# frozen_string_literal: true

module Hermes
  module BoClient
    class AddRequestTask < BaseTask
      
      def initialize(options = {})
        @xsd = "indiquerReference.xsd"
        super(options)
      end
      
      endpoint {'/ws/rest/als/demande/v1/indiquerReference'}
      
      task_name 'addrequest'
      mapping 'Hermes::BoClient::Mappings::HousingRequestMap'
      
      params :numUnique, :refInterne, :nomPatronymique, :prenoms, :dateNaissance
      
      def to_xml
        namespaces = {
          'xmlns:ns2' => 'http://v1.als.ikos.webservice.immobilier.sopra/demande/refDemande'
        }
        builder = Nokogiri::XML::Builder.new(encoding: 'UTF-8') do |b|
          b['ns2'].refDemande(namespaces) do
            self.class.param_definitions.each do |key, struct|
              seeked_elt = mapping.send(struct[:name])
              next unless seeked_elt
            
              b.send(key, seeked_elt) do |b|
                b.parent.namespace = nil
              end
            end
          end
        end
        builder.to_xml
      end

    end
  end
end
