namespace :hermes do
  desc "Update housing_requests als_ids"
  task :update_housing_requests_als_ids => :environment do
    Hermes::HousingRequest.update_all({ "$set" => { als_id: nil }})
    Hermes::HousingRequest.order_by(created_at: :asc).each do |hr|
      begin
        last_als_id = Hermes::HousingRequest.order_by(als_id: :desc).first.als_id

        if last_als_id
          hr.update_attribute(:als_id, '%010d' % (last_als_id.to_i + 1))
        else
          hr.update_attribute(:als_id, '%010d' % 1)
        end
      rescue Exception => e
        puts "Erreur update : #{e}"
      end
    end
  end

  desc "Update swagger"
  task :update_swagger => :environment do
    specs_file = `find packages/hermes/spec/apis/dmo -type f`.split("\n")
    command = "rspec #{specs_file.sort.join(' ')} --format Rswag::Specs::SwaggerFormatter --dry-run --order defined"
    exec(command)
  end
end