require 'rails_helper'

RSpec.describe Hermes::BoClient::Mappings::ApplicantReverseMap, type: :helper do
  describe 'work_contract_type mapping' do 
    [
      {sne_code: 'SAL', applicant_code: 'CDIP', cdd_interim: "true" },
      {sne_code: 'SAL', applicant_code: 'CDI'},
      {sne_code: 'AGE', applicant_code: 'AGP'},
      {sne_code: 'CHO', applicant_code: 'CHO'},
      {sne_code: 'ETA', applicant_code: 'APP', siret: 'siret'},
      {sne_code: 'ETA', applicant_code: 'ETU'},
      {sne_code: 'ASS', applicant_code: 'ASS'},
      {sne_code: 'AGH', applicant_code: 'AGH'},
      {sne_code: 'ACT', applicant_code: 'ACT'},
      {sne_code: 'IND', applicant_code: 'IND'},
      {sne_code: 'RET', applicant_code: 'RET'},
      {sne_code: 'AUTS', applicant_code: 'AUT'},
    ].each do |mapping|
      it "works for #{mapping[:sne_code]}" do
        expect(Hermes::BoClient::Mappings::ApplicantReverseMap.new(nil, nil).typeContratTravail_v4_map(mapping[:sne_code], mapping[:cdd_interim], mapping[:siret])).to eq(mapping[:applicant_code])
      end 
    end 
  end 
end